VHs = {{2,10},{13,11},{14,13},{13,15},{8,16}}

Storehouse = {{20,4}}
Store2 = {{14,13}}

-- In diese Tabelle werden alle eroberten Depots eingetragen, damit man den Bonus nur bei der 1. Eroberung erhllt
captured_depots = {}

Airfield = {{13,15}}

normal_wave_turns = {10,15}

string_1 = NSLOCTEXT("scenario_Antequera", "string_1", "Italian Auxiliaries")
string_2 = "Unsere italienischen Freunde habe die Corpo Volontarie Truppe in Marsch gesetzt um uns zu unterstuetzen. In Zukunft knnen wir italienische Hilfseinheiten kaufen." 
string_3 = NSLOCTEXT("scenario_Antequera", "string_3", "<bi>Oberleutnant Wagner: </>Antequera Airfield secured.  Ju-52 bomber conversions deploying for combat.")
string_4 = "Wir haben ein republikanisches Depot erobert. Der Inhalt stehlt als captured zum Kauf bzw. Update zur Verfuegung."

-- *** Hex zones ***
-- Spawn zones
-- When spawning a set of units, the script will scan spawn zones hex by hex, in the order specified, and spawn units in free hexes it finds
-- If the script runs out of hexes, the remainder of the units will not be spawned.
sr_spawn_zoneE = {{25,8},{26,8},{25,9},{26,9},{26,13},{27,13},{27,14},{28,14}}

-- *** Enemy waves ***
-- Each unit set is a list of blocks in the following format: { "<Unit ID>", "<Transport ID>", overstrength, experience }
-- If no organic transport is needed, its respective field should be empty string ("").

-- Spanish Republican wave
sr_wave1 = { {"SR37mmBofors", "HorseTransport", 0, 900}, {"152mmM10-30", "HorseTransport", 0, 900}, {"152mmM10-30", "HorseTransport", 0, 900}, {"SR20mmVKPLvz36AA", "HorseTransport", 0, 900}, {"SRInfantry", "", 0, 900}, {"SRInfantry", "", 0, 900}, {"UNL35", "", 0, 900}, {"I-15", "", 0, 900} }
sr_wave1 = { {"SR37mmBofors", "HorseTransport", 0, 900}, {"152mmM10-30", "HorseTransport", 0, 900}, {"152mmM10-30", "HorseTransport", 0, 900}, {"SR20mmVKPLvz36AA", "HorseTransport", 0, 900}, {"SRInfantry", "", 0, 900}, {"SRInfantry", "", 0, 900}, {"UNL35", "", 0, 900}, {"I-15", "", 0, 900} }

-- There can be any number of waves in this list, the game will pick a random one every time
sr_waves = {sr_wave1, sr_wave2}

-- There can be any number of zones in this list, the game will pick a random one every time
sr_zones = {sr_spawn_zoneE}


function OnCaptureStoreHouse(action)
	if IsItemInTable(captured_depots, action.flag) then return end	    -- Abfrage ob Depot bereits erobert ist

	-- If this flag was not captured by player 0 or 1 (Axis), do nothing
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end

	if IsItemInTable(Storehouse, action.flag) then	
		AddEquipment(0, "122mm M10-30", 20, captured)
		TutorialMessage(string_4)	
		table.insert(captured_depots, action.flag)		-- Merken, dass das Depot erobert wurde
	else
		return
	end
end

function Depot2(action)
	if IsItemInTable(captured_depots, action.flag) then return end	    -- Abfrage ob Depot bereits erobert ist

	-- If this flag was not captured by player 0 or 1 (Axis), do nothing
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end

	if IsItemInTable(Storehouse, action.flag) then	
		AddEquipment(0, "TrubiaNaval", 20, captured)
		TutorialMessage(string_4)	
		table.insert(captured_depots, action.flag)		-- Merken, dass das Depot erobert wurde
	else
		return
	end
end


function ItalyMsg(action)
	local player = world:GetPlayer(0)
	MessageBox(string_1,string_2)	
end

function CheckTurn()
	return world.round == 0 
end


function Player1VH()
	local p1captured = 0
	for _,vh in ipairs(VHs) do
		local hex = world:GetHex(vh)
		if hex.owner == 0 or hex.owner == 1 then
			p1captured = p1captured + 1
		end
	end

	return p1captured
end


function OnCaptureAF(action)
	-- If this flag was not captured by player 0 or 1 (Axis), do nothing
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end

	if IsItemInTable(captured_depots, action.flag) then return end	-- Abfrage ob Depot bereits erobert ist

	if IsItemInTable(Airfield, action.flag) then	
		player = 0
		zone = { {13,14},{14,14},{12,15},{13,15},{14,15},{13,16},{14,16} }
		units = { {"Ju52Bomber", "", 0, 0}, {"Ju52Bomber", "", 0, 0}, {"Ju52Bomber", "", 0, 0}  }

		SpawnWaveAir(player, zone, units)
		TutorialMessage(string_3)	
		table.insert(captured_depots, action.flag)		-- Merken, dass das Depot erobert wurde
	end
end

function Player1CustomSuccess(action)
	return action:GetActionClass() == "TurnsLimitAction" and Player1VH() > 0
end

function Player1CustomFail(action)
	return action:GetActionClass() == "TurnsLimitAction" and Player1VH() < 1
end

function Player1CustomSuccessB(action)
	return action:GetActionClass() == "TurnsLimitAction" and Player1VH() > 4
end

function Player1CustomFailB(action)
	return action:GetActionClass() == "TurnsLimitAction" and Player1VH() < 5
end


function SpawnWave(player, zone, units)
	local owner = world:GetPlayer(player)

	local cur_hex = 1

	-- Iterate through all units and spawn each one
	for _,u in ipairs(units) do
		-- Find the next vacant hex in the zone
		while zone[cur_hex] do
			hex = world:GetHex(zone[cur_hex])
			if hex:GetUnit(0) == nil then break end -- found
			cur_hex = cur_hex + 1
		end

		-- If we have run out of hexes in the zone, stop
		if not zone[cur_hex] then return end

		-- Create the unit in the free hex we've found
		-- 1. Create and execute purchase action, use unit type, transport type and overstrength as parameters
		local create_action = world:MakePurchaseAction(owner, u[1], u[2], u[3])
		create_action.auxiliary = false -- spawn core units
		create_action.cost = 0 -- don't take money for units we generate
		create_action.faction = owner.factions[1]  --set to first faction of owning player for created units
		world:Exec(create_action)

		-- 2. Create and execute deploy action, place the unit in the hex we've picked.
		local unit = world:GetUnit(create_action.id)
		deploy_action = world:MakeDeployAction(unit, zone[cur_hex])
		world:Exec(deploy_action)

		-- 3. Now modify the unit to set its experience to the value we need.
		unit.experience = u[4]
		
		-- 4. Now modify the unit to set its aggressiveness to the value we need.
		player_aggressiveness = { 0, 85, 70, 70 }
		unit.aggressiveness = player_aggressiveness[player+1]
		
	end
end

function SpawnWaveAir(player, zone, units)
	local owner = world:GetPlayer(player)

	local cur_hex = 1

	-- Iterate through all units and spawn each one
	for _,u in ipairs(units) do
		-- Find the next vacant hex in the zone
		while zone[cur_hex] do
			hex = world:GetHex(zone[cur_hex])
			if hex:GetUnit(1) == nil then break end -- found
			cur_hex = cur_hex + 1
		end

		-- If we have run out of hexes in the zone, stop
		if not zone[cur_hex] then return end

		-- Create the unit in the free hex we've found
		-- 1. Create and execute purchase action, use unit type, transport type and overstrength as parameters
		local create_action = world:MakePurchaseAction(owner, u[1], u[2], u[3])
		create_action.auxiliary = false -- spawn core units
		create_action.cost = 0 -- don't take money for units we generate
		create_action.faction = owner.factions[1]  --set to first faction of owning player for created units
		world:Exec(create_action)

		-- 2. Create and execute deploy action, place the unit in the hex we've picked.
		local unit = world:GetUnit(create_action.id)
		deploy_action = world:MakeDeployAction(unit, zone[cur_hex])
		world:Exec(deploy_action)

		-- 3. Now modify the unit to set its experience to the value we need.
		unit.experience = u[4]
		
		-- 4. Now modify the unit to set its aggressiveness to the value we need.
		player_aggressiveness = { 0, 85, 70, 50 }
		unit.aggressiveness = player_aggressiveness[player+1]
		
	end

end

function OnNewRound(action)
	-- On the first call, initialize the random generator
	if world.round == 1 then
		math.randomseed(world.seed)
	end

	-- Do we need to spawn a normal wave?
	local is_normal_wave = IsItemInTable(normal_wave_turns, world.round)

	if not is_normal_wave then return end

	-- Determine the player to get the next wave
	-- Player 2 for Spanish Republican Units
	player = 2

	-- Determine the right zone and units to spawn
	local zone
	local units

		zone = sr_zones[ math.random( #sr_zones ) ] -- random normal SR zone
		units = sr_waves[ math.random( #sr_waves ) ] -- random normal SR wave

	-- Now spawn this wave!
	SpawnWave(player, zone, units)
end

-- *** Utility functions ***
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end

	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

-- Possible categories: Prototypes, Captured, LimitedAvailability
function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end

function EmptyCondition()
	return true
end
