-- This table is initially empty, and will accumulate depots which we capture
-- Depots won't generate a bonus if we lose them and recapture for the second time
captured_depots = {}

Storehouse = {{5,18}}

string_4 = "General, wir haben das republikanische Depot erobert. Der Inhalt steht als captured fuer Kauf bzw. Update zur Verfuegung."

function OnCaptureStoreHouse(action)	
	if IsItemInTable(captured_depots, action.flag) then return end	    -- Abfrage ob Depot bereits erobert ist
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end	-- Wenn vom Feind erobert, nichts tun
	if IsItemInTable(Storehouse, action.flag) then		
		AddEquipment(0, "TrubiaNaval", 15, captured)
		AddEquipment(0, "UNL35", 20, captured)
		TutorialMessage(string_4)	
		table.insert(captured_depots, action.flag)		-- Merken, dass das Depot erobert wurde
	else
		return
	end
end


-- *** Utility functions ***
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end

	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end



--Nemesis scripts
string_1 = NSLOCTEXT("scenario_Merida", "string_1", "<bi>Oberleutnant Wagner: </>Heads up, mein General.  We've got eyes on a Republican officer on the field.  Apparently it's... Comandante Vega?")
string_2 = NSLOCTEXT("scenario_Merida", "string_2", "<bi>Capitana Vega: </>Before you ask, yes, he is my brother.  But make no mistake; he will forever be our enemy.  He will never be forgiven for the side he has chosen and things he has done in this war!")
string_3 = NSLOCTEXT("scenario_Merida", "string_3", "<bi>Capitana Vega: </>I urge utmost caution whenever you encounter his unit.  He is a most capable and relentless fighter.")
string_death = NSLOCTEXT("scenario_Merida", "string_death", "<bi>Capitana Vega: </>Rest in peace, my misguided brother.")

function NemesisTimer()
	return world.round == 4
end

function NemesisWarning(action)
	TutorialMessage(string_1)
	TutorialMessage(string_2, false)
	TutorialMessage(string_3, false)
end

function Condition2()
	local unit = world:GetUnit(33)
	return unit == nil 
end

function Effect2()
	if (campaign.nemesislives == 1) then
	TutorialMessage(string_death)
	campaign.nemesislives = 0
	end
end

function CreateAndAssignNemesis(unit_id)
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = NSLOCTEXT("scenario_Merida", "Nemesis", "")
	hero.extra_traits = {UnitTrait.Survivor, UnitTrait.Butcher, UnitTrait.TenaciousDefender}
	local action = world:MakeNewHeroAction(2, hero)
	world:Exec(action)

	local assign_hero_action = world:MakeAssignHeroAction(world:GetUnit(unit_id), hero.id)
	world:Exec(assign_hero_action)
end

function NemesisHero()
	CreateAndAssignNemesis(33) -- specify id of the unit which will get this hero
end
