-- Warnung in Runde 3
titel = "Warnung!"
string_1 = "Das Schlachtschiff 'Jaime I' und seine Eskorte blockiert nun den Seeweg. Wir muessen deshalb unsere Verbuendeten 'Army of Africa' ueber den Luftweg transportieren."

function Turn4MessageCondition()
	return world.round == 3
end

function Turn4MessageEffect()
	MessageBox(titel, string_1)
end


-- Wenn Spieler Hex {9,8} erobert, 25 Strkepunkte der Einheit 203mmM1931 als "captured" zuweisen
-- Spieler erhlt keine Einheit, sondern Strkepunkte unter "captured" zum Kauf oder Update
-- fr eigene Einheiten "prototypes" statt "captured" verwenden!

-- ntig im Editor unter Trigger:
-- Count: 0
-- Condition kann leer bleiben
-- Actions: CaptureFlagAction
-- Function: OnCaptureDepot

Ort = {{9,8}}
string_3 = "General, wir haben ein Lager mit Geschuetzen erobert. Diese stehen als captured fuer Kauf bzw. Update zur Verfuegung."

-- In diese Tabelle werden alle eroberten Depots eingetragen, damit man den Bonus nur bei der 1. Eroberung erhllt
captured_depots = {}

-- nur ausfhren, wenn Spieler (player0) {9,8} erobert
function OnCaptureOrt(action)
	if (action.new_owner == 0 and IsItemInTable(Ort, action.flag)) then
		if IsItemInTable(captured_depots, action.flag) then return end	    -- Abfrage ob Depot bereits erobert ist
		AddEquipment(0, "203mmM1931", 25, captured)	-- AddEquipment kann man hier auch mehrfach aufrufen
		TutorialMessage(string_3)					-- Nachricht an Spieler
		table.insert(captured_depots, action.flag)		-- Merken, dass das Depot erobert wurde
	else
		return
	end
end

-- die 3 hierfr ntigen Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end


-- Jede Runde prfen, ob Feindwelle getriggert wird
normal_wave_turns = {10,16}

-- Spawn zones
-- When spawning a set of units, the script will scan spawn zones hex by hex, in the order specified, and spawn units in free hexes
-- If the script runs out of hexes, the remainder of the units will not be spawned.
sr_spawn_zoneNE = {{17,2},{18,2},{17,3},{18,3},{26,8},{25,9},{26,10},{26,11}}

-- *** Enemy waves ***
-- Each unit set is a list of blocks in the following format: { "<Unit ID>", "<Transport ID>", overstrength, experience }
-- Spanish Republican wave
sr_wave1 = { {"SR37mmBofors", "HorseTransport", 0, 900}, {"70mmSchneiderM08", "HorseTransport", 0, 900}, {"70mmSchneiderM08", "HorseTransport", 0, 900}, {"SR20mmVKPLvz36AA", "HorseTransport", 0, 900}, {"SRInfantry", "", 0, 900}, {"SRInfantry", "", 0, 900}, {"UNL35", "", 0, 900} }
sr_wave1 = { {"SR37mmBofors", "HorseTransport", 0, 900}, {"70mmSchneiderM08", "HorseTransport", 0, 900}, {"70mmSchneiderM08", "HorseTransport", 0, 900}, {"SR20mmVKPLvz36AA", "HorseTransport", 0, 900}, {"SRInfantry", "", 0, 900}, {"SRInfantry", "", 0, 900}, {"UNL35", "", 0, 900} }

-- There can be any number of waves in this list, the game will pick a random one every time
sr_waves = {sr_wave1, sr_wave2}

-- There can be any number of zones in this list, the game will pick a random one every time
sr_zones = {sr_spawn_zoneNE}

function SpawnWave(player, zone, units)
	local owner = world:GetPlayer(player)
	local cur_hex = 1

	-- Iterate through all units and spawn each one
	for _,u in ipairs(units) do
		-- Find the next vacant hex in the zone
		while zone[cur_hex] do
			hex = world:GetHex(zone[cur_hex])
			if hex:GetUnit(0) == nil then break end -- found
			cur_hex = cur_hex + 1
		end

		-- If we have run out of hexes in the zone, stop
		if not zone[cur_hex] then return end

		-- Create the unit in the free hex we've found
		-- 1. Create and execute purchase action, use unit type, transport type and overstrength as parameters
		local create_action = world:MakePurchaseAction(owner, u[1], u[2], u[3])
		create_action.auxiliary = false -- spawn core units
		create_action.cost = 0 -- don't take money for units we generate
		create_action.faction = owner.factions[1]  --set to first faction of owning player for created units
		world:Exec(create_action)

		-- 2. Create and execute deploy action, place the unit in the hex we've picked.
		local unit = world:GetUnit(create_action.id)
		deploy_action = world:MakeDeployAction(unit, zone[cur_hex])
		world:Exec(deploy_action)

		-- 3. Now modify the unit to set its experience to the value we need.
		unit.experience = u[4]
		
		-- 4. Now modify the unit to set its aggressiveness to the value we need.
		player_aggressiveness = { 0, 85, 70, 70 }
		unit.aggressiveness = player_aggressiveness[player+1]
		
	end
end

function OnNewRound(action)
	-- On the first call, initialize the random generator
	if world.round == 1 then
		math.randomseed(world.seed)
	end

	-- Do we need to spawn a normal wave?
	local is_normal_wave = IsItemInTable(normal_wave_turns, world.round)

	-- If we don't need to spawn any normal or boss waves this turn then just finish
	if not is_normal_wave then return end

	-- Determine the player to get the next wave (Player 1 for Spanish Republican Units)
	player = 1

	-- Determine the right zone and units to spawn
	local zone
	local units
	zone = sr_zones[ math.random( #sr_zones ) ] -- random normal SR zone
	units = sr_waves[ math.random( #sr_waves ) ] -- random normal SR wave

	-- Now spawn this wave!
	SpawnWave(player, zone, units)
end

function AlwaysTrue()
	return true
end


-- Kommandopanzer IA zuweisen
function Runde0()
	return world.round == 0		
end

meldung = "Es wurde ein Kommandopanzer IA bereitgestellt."

function unit1()
	local feld = {11,38}
	local einheit = "CommandPanzerIA"	
	local player = world:GetPlayer(0)
	local create_action = world:MakePurchaseAction(player, einheit, "", 0)
	create_action.auxiliary = false
	create_action.cost = 0
	world:Exec(create_action)
	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	deploy_action = world:MakeDeployAction(unit,feld)
	world:Exec(deploy_action)
	TutorialMessage(meldung)	
end
