-- This table is initially empty, and will accumulate depots which we capture
-- Depots won't generate a bonus if we lose them and recapture for the second time
captured_depots = {}

Storehouse1 = {{19,15}}
Storehouse2 = {{16,25}}

string = "General, wir haben ein republikanisches Depot erobert. Der Inhalt steht als captured fuer Kauf bzw. Update zur Verfuegung."

function OnCaptureStoreHouse1(action)	
	if IsItemInTable(captured_depots, action.flag) then return end	    -- Abfrage ob Depot bereits erobert ist
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end	-- Wenn vom Feind erobert, nichts tun
	if IsItemInTable(Storehouse1, action.flag) then		
		AddEquipment(0, "TrubiaNaval", 25, captured)
		AddEquipment(0, "203mmM1931", 5, captured)
		TutorialMessage(string)
		table.insert(captured_depots, action.flag)		-- Merken, dass das Depot erobert wurde
	else
		return
	end
end

function OnCaptureStoreHouse2(action)	
	if IsItemInTable(captured_depots, action.flag) then return end	    -- Abfrage ob Depot bereits erobert ist
	if(action.new_owner ~= 0 and action.new_owner ~= 1) then return end	-- Wenn vom Feind erobert, nichts tun
	if IsItemInTable(Storehouse2, action.flag) then		
		AddEquipment(0, "BT5", 30, captured)
		TutorialMessage(string)	
		table.insert(captured_depots, action.flag)		-- Merken, dass das Depot erobert wurde
	else
		return
	end
end

-- *** Utility functions ***
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end

	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end

