function CreateAndAssignEnemyHero1(unit_id)
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = NSLOCTEXT("scenario_Bilbao", "EnemyHero", "")
	hero.extra_traits = {UnitTrait.IncMaxOverstrength, UnitTrait.IncMaxOverstrength}
	local action = world:MakeNewHeroAction(2, hero)
	world:Exec(action)

	local assign_hero_action = world:MakeAssignHeroAction(world:GetUnit(unit_id), hero.id)
	world:Exec(assign_hero_action)
end

function EnemyHero()
	CreateAndAssignEnemyHero1(90) -- specify id of the unit which will get this hero
end


string = "Wir haben ein feindliches Depot erobert."

function OnObjective(action)
	if (action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success) then
		AddEquipment(0, "BT5", 15, captured)	
		AddEquipment(0, "203mmM1931", 5, captured)	
		TutorialMessage(string)					
	end
end

-- die 3 hierfr ntigen Hilfsfunktionen:
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

function AddEquipment(player_id, unit_type, quantity, category)	-- eigentliche Funktion um Equipment hinzuzufgen
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end
