string = "Wir haben ein feindliches Depot erobert."

function OnObjective1(action)
	if (action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success) then
		AddEquipment(0, "T26", 25, captured)
		AddEquipment(0, "PolikarpovI16", 25, captured)
		TutorialMessage(string)					
	end
end

-- *** Utility functions ***
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end


--Nemesis scripts
string_death = NSLOCTEXT("scenario_Brunete", "string_death", "<bi>Capitana Vega: </>Rest in peace, my misguided brother.")

function Condition2()
	local unit = world:GetUnit(86)
	return unit == nil 
end

function Effect2()
	if (campaign.nemesislives == 1) then
	TutorialMessage(string_death)
	campaign.nemesislives = 0
	end
end

function NemesisCheck()
	if (campaign.nemesislives == 0) then
   		local nemesis = world:GetUnit(86)
   		local death_action = world:MakeDeathAction(nemesis)
   		world:Exec(death_action)
	end
end

function CreateAndAssignNemesis(unit_id)
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = NSLOCTEXT("scenario_Brunete", "Nemesis", "")
	hero.extra_traits = {UnitTrait.IgnoresZOC, UnitTrait.Survivor, UnitTrait.Butcher, UnitTrait.TenaciousDefender}
	local action = world:MakeNewHeroAction(2, hero)
	world:Exec(action)

	local assign_hero_action = world:MakeAssignHeroAction(world:GetUnit(unit_id), hero.id)
	world:Exec(assign_hero_action)
end

function NemesisHero()
	CreateAndAssignNemesis(86) -- specify id of the unit which will get this hero
end


function CreateAndAssignEnemyHero1(unit_id)
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = NSLOCTEXT("scenario_Brunete", "EnemyHero", "")
	hero.extra_traits = {UnitTrait.IncMaxOverstrength, UnitTrait.Unyielding}
	local action = world:MakeNewHeroAction(2, hero)
	world:Exec(action)

	local assign_hero_action = world:MakeAssignHeroAction(world:GetUnit(unit_id), hero.id)
	world:Exec(assign_hero_action)
end

function EnemyHero()
	CreateAndAssignEnemyHero1(52) -- specify id of the unit which will get this hero
end
