-- *** Special turns ***
boss_wave_turns = {5,13,21}
normal_wave_turns = {2,4,6,8,10,12,14,16,18,20,22,24}

-- *** Hex zones ***
-- Spawn zones
-- When spawning a set of units, the script will scan spawn zones hex by hex, in the order specified, and spawn units in free hexes it finds
-- If the script runs out of hexes, the remainder of the units will not be spawned.
A_spawn_zone = {{50,5},{51,5},{52,5},{51,6},{52,6},{53,6},{51,7},{52,7},{53,7},{52,8},{53,8},{54,8},{52,9},{53,9},{54,9},{53,10},{54,10},{55,10}}
B_spawn_zone = {{54,25},{55,25},{54,26},{55,26},{53,27},{54,27},{53,28},{54,28},{52,29},{53,29},{52,30},{53,30},{51,31},{52,31}}
C_spawn_zone = {{52,44},{53,44},{54,44},{51,45},{52,45},{53,45},{51,46},{52,46},{53,46},{50,47},{51,47},{51,48},{52,48},{51,49}}
D_spawn_zone = {{25,45},{26,45},{27,45},{25,46},{26,46},{27,46},{28,46},{24,47},{26,47},{27,47},{25,48},{26,48},{27,48},{28,48},{29,48}}
E_spawn_zone = {{9,46},{10,46},{11,46},{12,46},{13,46},{8,47},{9,47},{10,47},{12,47},{13,47},{9,48},{10,48},{11,48},{12,48},{13,48},{14,48}}

-- *** Enemy waves ***
-- Each unit set is a list of blocks in the following format: { "<Unit ID>", "<Transport ID>", overstrength, experience }
-- If no organic transport is needed, its respective field should be empty string ("").

-- normal NorthEast waves
A_wave1 = { {"Guards", "SUTruck", 0, 1000}, {"Guards", "SUTruck", 0, 1000}, {"T34-43", "", 3, 1000}, {"T34-85", "", 4, 1000}, {"SU85", "", 3, 1000}, {"BM13Katyusha", "", 3, 1000} }
A_wave2 = { {"Guards", "SUTruck", 0, 1000}, {"Guards", "SUTruck", 0, 1000}, {"T34-43", "", 3, 1000}, {"T34-85", "", 4, 1000}, {"SU85", "", 3, 1000}, {"BM13Katyusha", "", 3, 1000} }
A_wave3 = { {"Conscript", "", 0, 1000}, {"Conscript", "", 0, 1000}, {"IS2", "", 4, 2000},  {"ISU122AT", "", 2, 1000}, {"SU6AA", "", 1, 1000} }
A_wave4 = { {"Regular43", "", 0, 1000}, {"Regular43", "", 0, 1000}, {"T34-85", "", 3, 2000},  {"T34-85", "", 3, 1000}, {"SU122ATY", "", 2, 1000},  {"T34-57", "", 4, 1000} }
A_wave5 = { {"Regular43", "", 0, 1000}, {"BA10", "", 4, 1000}, {"BA10", "", 4, 1000}, {"SU85", "", 2, 1000}, {"BM8_8", "", 2, 1000}, {"BM8_8", "", 3, 1000}, {"OT34", "", 3, 1000}, }

-- There can be any number of waves in this list, the game will pick a random one every time
A_waves = {A_wave1, A_wave2, A_wave3, A_wave4, A_wave5}

-- normal East waves
B_wave1 = { {"Guards", "SUTruck", 0, 1000}, {"Guards", "SUTruck", 0, 1000}, {"T34-43", "", 3, 1000}, {"T34-85", "", 4, 1000}, {"SU85", "", 3, 1000}, {"BM13Katyusha", "", 3, 1000} }
B_wave2 = { {"Guards", "SUTruck", 0, 1000}, {"Guards", "SUTruck", 0, 1000}, {"T34-43", "", 3, 1000}, {"T34-85", "", 4, 1000}, {"SU85", "", 3, 1000}, {"BM13Katyusha", "", 3, 1000} }
B_wave3 = { {"Conscript", "", 0, 1000}, {"Conscript", "", 0, 1000}, {"IS2", "", 4, 2000},  {"ISU122AT", "", 2, 1000}, {"SU6AA", "", 1, 1000} }
B_wave4 = { {"Regular43", "", 0, 1000}, {"Regular43", "", 0, 1000}, {"T34-85", "", 3, 2000},  {"T34-85", "", 3, 1000}, {"SU122ATY", "", 2, 1000},  {"T34-57", "", 4, 1000} }
B_wave5 = { {"Regular43", "", 0, 1000}, {"BA10", "", 4, 1000}, {"BA10", "", 4, 1000}, {"SU85", "", 2, 1000}, {"BM8_8", "", 2, 1000}, {"BM8_8", "", 3, 1000}, {"OT34", "", 3, 1000}, }

-- There can be any number of waves in this list, the game will pick a random one every time
B_waves = {B_wave1, B_wave2, B_wave3, B_wave4, B_wave5}

-- normal SouthEast waves
C_wave1 = { {"Guards", "SUTruck", 0, 1000}, {"Guards", "SUTruck", 0, 1000}, {"T34-43", "", 3, 1000}, {"T34-85", "", 4, 1000}, {"SU85", "", 3, 1000}, {"BM13Katyusha", "", 3, 1000} }
C_wave2 = { {"Guards", "SUTruck", 0, 1000}, {"Guards", "SUTruck", 0, 1000}, {"T34-43", "", 3, 1000}, {"T34-85", "", 4, 1000}, {"SU85", "", 3, 1000}, {"BM13Katyusha", "", 3, 1000} }
C_wave3 = { {"Conscript", "", 0, 1000}, {"Conscript", "", 0, 1000}, {"IS2", "", 4, 2000},  {"ISU122AT", "", 2, 1000}, {"SU6AA", "", 1, 1000} }
C_wave4 = { {"Regular43", "", 0, 1000}, {"Regular43", "", 0, 1000}, {"T34-85", "", 3, 2000},  {"T34-85", "", 3, 1000}, {"SU122ATY", "", 2, 1000},  {"T34-57", "", 4, 1000} }
C_wave5 = { {"Regular43", "", 0, 1000}, {"BA10", "", 4, 1000}, {"BA10", "", 4, 1000}, {"SU85", "", 2, 1000}, {"BM8_8", "", 2, 1000}, {"BM8_8", "", 3, 1000}, {"OT34", "", 3, 1000}, }

-- There can be any number of waves in this list, the game will pick a random one every time
C_waves = {C_wave1, C_wave2, C_wave3, C_wave4, C_wave5}

-- normal South waves
D_wave1 = { {"Guards", "SUTruck", 0, 1000}, {"Guards", "SUTruck", 0, 1000}, {"T34-43", "", 3, 1000}, {"T34-85", "", 4, 1000}, {"SU85", "", 3, 1000}, {"BM13Katyusha", "", 3, 1000} }
D_wave2 = { {"Guards", "SUTruck", 0, 1000}, {"Guards", "SUTruck", 0, 1000}, {"T34-43", "", 3, 1000}, {"T34-85", "", 4, 1000}, {"SU85", "", 3, 1000}, {"BM13Katyusha", "", 3, 1000} }
D_wave3 = { {"Conscript", "", 0, 1000}, {"Conscript", "", 0, 1000}, {"IS2", "", 4, 2000},  {"ISU122AT", "", 2, 1000}, {"SU6AA", "", 1, 1000} }
D_wave4 = { {"Regular43", "", 0, 1000}, {"Regular43", "", 0, 1000}, {"T34-85", "", 3, 2000},  {"T34-85", "", 3, 1000}, {"SU122ATY", "", 2, 1000},  {"T34-57", "", 4, 1000} }
D_wave5 = { {"Regular43", "", 0, 1000}, {"BA10", "", 4, 1000}, {"BA10", "", 4, 1000}, {"SU85", "", 2, 1000}, {"BM8_8", "", 2, 1000}, {"BM8_8", "", 3, 1000}, {"OT34", "", 3, 1000}, }

-- There can be any number of waves in this list, the game will pick a random one every time
D_waves = {D_wave1, D_wave2, D_wave3, D_wave4, D_wave5}

-- normal SouthWest waves
E_wave1 = { {"Guards", "SUTruck", 0, 1000}, {"Guards", "SUTruck", 0, 1000}, {"T34-43", "", 3, 1000}, {"T34-85", "", 4, 1000}, {"SU85", "", 3, 1000}, {"BM13Katyusha", "", 3, 1000} }
E_wave2 = { {"Guards", "SUTruck", 0, 1000}, {"Guards", "SUTruck", 0, 1000}, {"T34-43", "", 3, 1000}, {"T34-85", "", 4, 1000}, {"SU85", "", 3, 1000}, {"BM13Katyusha", "", 3, 1000} }
E_wave3 = { {"Conscript", "", 0, 1000}, {"Conscript", "", 0, 1000}, {"IS2", "", 4, 2000},  {"ISU122AT", "", 2, 1000}, {"SU6AA", "", 1, 1000} }
E_wave4 = { {"Regular43", "", 0, 1000}, {"Regular43", "", 0, 1000}, {"T34-85", "", 3, 2000},  {"T34-85", "", 3, 1000}, {"SU122ATY", "", 2, 1000},  {"T34-57", "", 4, 1000} }
E_wave5 = { {"Regular43", "", 0, 1000}, {"BA10", "", 4, 1000}, {"BA10", "", 4, 1000}, {"SU85", "", 2, 1000}, {"BM8_8", "", 2, 1000}, {"BM8_8", "", 3, 1000}, {"OT34", "", 3, 1000}, }

-- There can be any number of waves in this list, the game will pick a random one every time
E_waves = {E_wave1, E_wave2, E_wave3, E_wave4, E_wave5}


ru_boss_wave1 = { {"SUMntInf43", "", 3, 3999}, {"SUMntInf43", "", 3, 3999}, {"T90SPAAG-AA", "", 3, 3999}, {"T34-85", "", 3, 3999}, {"T34-85", "", 3, 3999}, {"BM13Katyusha", "", 3, 3999}, {"BA64", "", 3, 3999} }
ru_boss_wave2 = { {"SUHWInf43", "", 4, 4999}, {"SUHWInf43", "", 4, 4999}, {"T90SPAAG-AA", "", 4, 4999}, {"SU57", "", 4, 4999}, {"SU57", "", 4, 4999}, {"SU57", "", 4, 4999}, {"BA10", "", 4, 4999} }
ru_boss_wave3 = { {"SUEngineers43", "", 5, 5999}, {"SUEngineers43", "", 5, 5999}, {"T90SPAAG-AA", "", 5, 5999}, {"IS1", "", 5, 5999}, {"KV85", "", 5, 5999}, {"BM31Katyusha", "", 5, 5999}, {"BA64", "", 5, 5999} }

-- For each turn in boss_wave_turns there must be one corresponding boss wave in this list
ru_boss_waves = { ru_boss_wave1, ru_boss_wave2, ru_boss_wave3 }


-- *** Utility functions ***
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

function SpawnWave(player, zone, units)
	local owner = world:GetPlayer(player)
	local cur_hex = 1

	-- Iterate through all units and spawn each one
	for _,u in ipairs(units) do
		-- Find the next vacant hex in the zone
		while zone[cur_hex] do
			hex = world:GetHex(zone[cur_hex])
			if hex:GetUnit(0) == nil then break end -- found
			cur_hex = cur_hex + 1
		end

		-- If we have run out of hexes in the zone, stop
		if not zone[cur_hex] then return end

		-- Create the unit in the free hex we've found
		-- 1. Create and execute purchase action, use unit type, transport type and overstrength as parameters
		local create_action = world:MakePurchaseAction(owner, u[1], u[2], u[3])
		create_action.auxiliary = false -- spawn core units
		create_action.cost = 0 -- don't take money for units we generate
		world:Exec(create_action)

		-- 2. Create and execute deploy action, place the unit in the hex we've picked.
		local unit = world:GetUnit(create_action.id)
		deploy_action = world:MakeDeployAction(unit, zone[cur_hex])
		world:Exec(deploy_action)

		-- 3. Now modify the unit to set its experience to the value we need.
		unit.experience = u[4]
		
		-- 4. Now modify the unit to set its aggressiveness to the value we need.
		player_aggressiveness = { 0, 0, 80, 50 }
		unit.aggressiveness = player_aggressiveness[player+1]
	end
end

-- *** Triggers ***
-- The following functions are called by the triggers created in the scenario file

-- This condition is empty (always true)
function EmptyCondition()
	return true
end

-- This function will be called every time a new turn starts
function OnNewRound(action)
	-- On the first call, initialize the random generator
	if world.round == 1 then
		math.randomseed(world.seed)
	end

	-- Do we need to spawn a normal wave?
	local is_normal_wave = IsItemInTable(normal_wave_turns, world.round)

	-- Do we need to spawn a boss wave?
	local boss_wave = FindItemInTable(boss_wave_turns, world.round) -- boss wave number
	local is_boss_wave = (boss_wave ~= -1)

	-- If we don't need to spawn any normal or boss waves this turn then just finish
	if not is_normal_wave and not is_boss_wave then return end

	-- Determine the player to get the next wave
	-- Germany is player 0 and 1, so AI players are 2 and 3
	player = 2

	-- Determine the right zone and units to spawn
	local zone
	zone = math.random(1, 5)
	local units

	if zone == 1 then
		-- Zone is NE
		zone = A_spawn_zone
		if is_boss_wave then
			player = 3
			units = ru_boss_waves[ math.random( #ru_boss_waves ) ] -- random elite wave
		else
			units = A_waves[ math.random( #A_waves ) ] -- random normal A wave
		end
	elseif zone == 2 then
		-- Zone is E
		zone = B_spawn_zone
		if is_boss_wave then
			player = 3
			units = ru_boss_waves[ math.random( #ru_boss_waves ) ] -- random elite wave
		else
			units = B_waves[ math.random( #B_waves ) ] -- random normal B wave
		end
	elseif zone == 3 then
		-- Zone is SE
		zone = C_spawn_zone
		if is_boss_wave then
			player = 3
			units = ru_boss_waves[ math.random( #ru_boss_waves ) ] -- random elite wave
		else
			units = C_waves[ math.random( #C_waves ) ] -- random normal C wave
		end
	elseif zone == 4 then
		-- Zone is S
		zone = D_spawn_zone
		if is_boss_wave then
			player = 3
			units = ru_boss_waves[ math.random( #ru_boss_waves ) ] -- random elite wave
		else
			units = D_waves[ math.random( #D_waves ) ] -- random normal D wave
		end
	else
		-- Zone is SW
		zone = E_spawn_zone
		if is_boss_wave then
			player = 3
			units = ru_boss_waves[ math.random( #ru_boss_waves ) ] -- random elite wave
		else
			units = E_waves[ math.random( #E_waves ) ] -- random normal E wave
		end
	end

	-- Now spawn this wave!
	SpawnWave(player, zone, units)
end
